<?php

class TagHandlers {
	// Class constructor
	function TagHandlers($tmp) {
		$this->tmp = $tmp;
  }
  
	// Post tags
	function Posts($token, $parameters) {
		global $wp_query;
		$posts = $wp_query->posts;
		$parsed_text = '';
		
		foreach ($posts as $post) {
			$parameters->post = $post;
			$parsed_text .= $this->tmp->call_handlers($parameters, $token['block'], $this);
		}
		return $parsed_text;
	}
	function PostID($token, $parameters) {
   return $parameters->post->post_ID;
  }
	
	function PostTitle($token, $parameters) {
   return $parameters->post->post_title;
  }
	function PostContent($token, $parameters) {
   return $parameters->post->post_content;
  }
	function PostDate($token, $parameters) {
		if ($token['attributes']['gmt'] == true) {
		 return $parameters->post->post_date_gmt;
		} else {
	   return $parameters->post->post_date;
		}
  }
	function PostAuthor($token, $parameters) {
   return $parameters->post->post_author;
  }
	function PostExcerpt($token, $parameters) {
   return $parameters->post->post_excerpt;
  }
	function PostStatus($token, $parameters) {
   return $parameters->post->post_status;
  }
	function PostName($token, $parameters) {
   return $parameters->post->post_name;
  }
	function PostModified($token, $parameters) {
   if ($token['attributes']['gmt'] == true) {
		 return $parameters->post->post_modified_gmt;
		} else {
	   return $parameters->post->post_modified;
		}
  }
	function PostCommentCount($token, $parameters) {
   return $parameters->post->post_comment_count;
  }
	function PostType($token, $parameters) {
   return $parameters->post->post_type;
  }
	
	// Link Tags
  function LinkCategories($token, $parameters) {
		$output='';
  	$order = (!isset($token['attributes']['order'])) ? 'name' : $token['attributes']['order'];
  	$hide_if_empty = (!isset($token['attributes']['hide_if_empty'])) ? 'name' : $token['attributes']['hide_if_empty'];
  	
  	global $wpdb;
  
  	$order = strtolower($order);
  
  	// Handle link category sorting
  	if (substr($order,0,1) == '_') {
  		$direction = ' DESC';
  		$order = substr($order,1);
  	}
  
  	// if 'name' wasn't specified, assume 'id':
  	$cat_order = ('name' == $order) ? 'cat_name' : 'cat_id';
  
  	if (!isset($direction)) $direction = '';
  	// Fetch the link category data as an array of hashes
  	$cats = $wpdb->get_results("SELECT DISTINCT link_category, cat_name, show_images, show_description, show_rating, show_updated, sort_order, sort_desc, list_limit " .
  		"FROM `$wpdb->links` LEFT JOIN `$wpdb->linkcategories` ON (link_category = cat_id) " .
  		"WHERE link_visible =  'Y' " .
  		"  AND list_limit <> 0 " .
  		"ORDER BY $cat_order $direction ", ARRAY_A);
  	//echo var_dump($cats);
  	// Display each category
  	if ($cats) {
  		foreach ($cats as $cat) {
  			$parameters->linkcat = $cat;
				$output .= $this->tmp->call_handlers($parameters, $token['block'], $this);
  		}
  	}
		return $output;
  }

	function LinkCategoryName ($token, $parameters) {
			//echo var_dump($parameters);
	 		return $parameters->linkcat['cat_name'];
	}
	function LinkCategoryID ($token, $parameters) {
	 		return $parameters->linkcat['link_category'];
	}
	
	
	/** function get_links()
 ** Gets the links associated with category n.
 ** Parameters:
 **   category (default -1)  - The category to use. If no category supplied
 **      uses all
 **   before (default '')  - the html to output before the link
 **   after (default '<br />')  - the html to output after the link
 **   between (default ' ')  - the html to output between the link/image
 **     and its description. Not used if no image or show_images == true
 **   show_images (default true) - whether to show images (if defined).
 **   orderby (default 'id') - the order to output the links. E.g. 'id', 'name',
 **     'url', 'description', or 'rating'. Or maybe owner. If you start the
 **     name with an underscore the order will be reversed.
 **     You can also specify 'rand' as the order which will return links in a
 **     random order.
 **   show_description (default true) - whether to show the description if
 **    show_images=false/not defined .
 **   show_rating (default false) - show rating stars/chars
 **   limit (default -1) - Limit to X entries. If not specified, all entries
 **     are shown.
 **   show_updated (default 0) - whether to show last updated timestamp
 */
function Links($token, $parameters) {
	$output = '';
	$category = (!isset($token['attributes']['category'])) ? -1 : $token['attributes']['category'];
	$orderby = (!isset($token['attributes']['orderby'])) ? 'name' : $token['attributes']['orderby'];
	$before = (!isset($token['attributes']['before'])) ? '' : $token['attributes']['before'];
  $after = (!isset($token['attributes']['after'])) ? '<br />' : $token['attributes']['after'];
	$between = (!isset($token['attributes']['between'])) ? ' ' : $token['attributes']['between'];
	$show_images = (!isset($token['attributes']['show_images'])) ? true : $token['attributes']['show_images'];
	$show_description = (!isset($token['attributes']['show_description'])) ? true : $token['attributes']['show_description'];
	$show_rating = (!isset($token['attributes']['show_rating'])) ? false : $token['attributes']['show_rating'];
	$limit = (!isset($token['attributes']['limit'])) ? -1 : $token['attributes']['limit'];
	$show_updated = (!isset($token['attributes']['show_updated'])) ? 1 : $token['attributes']['show_updated'];
	if (isset($parameters->linkcat)) {
		$category = $parameters->linkcat['link_category'];
		echo $category;
	}

	global $wpdb;
	$direction = ' ASC';
	$category_query = '';
	if ($category != -1) {
		$category_query = " AND link_category = $category ";
	}
	if (get_settings('links_recently_updated_time')) {
		$recently_updated_test = ", IF (DATE_ADD(link_updated, INTERVAL " . get_settings('links_recently_updated_time') . " MINUTE) >= NOW(), 1,0) as recently_updated ";
	} else {
		$recently_updated_test = '';
	}
	if ($show_updated) {
		$get_updated = ", UNIX_TIMESTAMP(link_updated) AS link_updated_f ";
	}

	$orderby = strtolower($orderby);
	if ($orderby == '')
		$orderby = 'id';
	if (substr($orderby, 0, 1) == '_') {
		$direction = ' DESC';
		$orderby = substr($orderby, 1);
	}

	switch($orderby) {
		case 'length':
		$length = ", CHAR_LENGTH(link_name) AS length";
		break;
		case 'rand':
			$orderby = 'rand()';
			break;
		default:
			$orderby = " link_" . $orderby;
	}

	if (!isset($length)) {
		$length = '';
	}

	$sql = "SELECT link_url, link_name, link_image, link_target, link_description, link_rating, link_rel $length $recently_updated_test $get_updated FROM $wpdb->links WHERE link_visible = 'Y' " . $category_query;
	$sql .= ' ORDER BY ' . $orderby . $direction;
	/* The next 2 lines implement LIMIT TO processing */
	if ($limit != -1)
		$sql .= " LIMIT $limit";
	$results = $wpdb->get_results($sql);
	if (!$results) {
		return;
	}
	
	if ($token['type'] == 'container') {
		//echo var_dump($token);
		foreach ($results as $row) {
			$parameters->linkrow = $row;
			$output .= $this->tmp->call_handlers($parameters, $token['block'], $this);
		}
	} else {	
  	foreach ($results as $row) {
  		if (!isset($row->recently_updated)) $row->recently_updated = false;
  			$output .= $before;
  		if ($show_updated && $row->recently_updated) {
  			$output .= get_settings('links_recently_updated_prepend');
  		}
  
  		$the_link = '#';
  		if (!empty($row->link_url))
  			$the_link = wp_specialchars($row->link_url);
  
  		$rel = $row->link_rel;
  		if ($rel != '') {
  			$rel = ' rel="' . $rel . '"';
  		}
  
  		$desc = wp_specialchars($row->link_description, ENT_QUOTES);
  		$name = wp_specialchars($row->link_name, ENT_QUOTES);
  		$title = $desc;
  
  		if ($show_updated) {
  			if (substr($row->link_updated_f, 0, 2) != '00') {
  				$title .= ' (Last updated ' . date(get_settings('links_updated_date_format'), $row->link_updated_f + (get_settings('gmt_offset') * 3600)) . ')';
  			}
  		}
  
  		if ('' != $title) {
  			$title = ' title="' . $title . '"';
  		}
  
  		$alt = ' alt="' . $name . '"';
  
  		$target = $row->link_target;
  		if ('' != $target) {
  			$target = ' target="' . $target . '"';
  		}
  
  		$output .= '<a href="' . $the_link . '"' . $rel . $title . $target. '>';
  
  		if (($row->link_image != null) && $show_images) {
  			if (strstr($row->link_image, 'http'))
  				$output .= "<img src=\"$row->link_image\" $alt $title />";
  			else // If it's a relative path
  				$output .= "<img src=\"" . get_settings('siteurl') . "$row->link_image\" $alt $title />";
  		} else {
  			$output .= $name;
  		}
  
  		$output .= '</a>';
  
  		if ($show_updated && $row->recently_updated) {
  			$output .= get_settings('links_recently_updated_append');
  		}
  
  		if ($show_description && ($desc != '')) {
  			$output .= $between . $desc;
  		}
  		$output .= "$after\n";
  	} // end while
	}
	return $output;
}
function LinkUrl($token, $parameters) {
	return $parameters->linkrow->link_url;
}
function LinkName($token, $parameters) {
	return $parameters->linkrow->link_name;
}
function LinkImageURL($token, $parameters) {
	return $parameters->linkrow->link_image;
}
function LinkTarget($token, $parameters) {
	return $parameters->linkrow->link_target;
}
function LinkDescription($token, $parameters) {
	return $parameters->linkrow->link_description;
}
function LinkRating($token, $parameters) {
	return $parameters->linkrow->link_rating;
}
function LinkRel($token, $parameters) {
	return $parameters->linkrow->link_rel;
}
function LinkRecentlyUpdatedBoolean($token, $parameters) {
	return $parameters->linkrow->recently_updated;
}
function LinkUpdatedTime($token, $parameters) {
	return $parameters->linkrow->link_updated_f;
}


// Author Tags
function Authors($token, $parameters) {
	$output = '';
	global $wpdb;
	$query = "SELECT ID, user_nicename from $wpdb->users " . ($exclude_admin ? "WHERE user_login <> 'admin' " : '') . "ORDER BY display_name";
	$authors = $wpdb->get_results($query);
	
	if ($token['type'] == 'container') {
		//echo var_dump($token);
		foreach ( $authors as $author ) {
			$parameters->author = $author;
			$output .= $this->tmp->call_handlers($parameters, $token['block'], $this);
		}
	} else {	
		foreach ( $authors as $author ) {
 		
  		$author = get_userdata( $author->ID );
  		$posts = get_usernumposts($author->ID);
  		$name = $author->nickname;
  
  		if ( $show_fullname && ($author->first_name != '' && $author->last_name != '') )
  			$name = "$author->first_name $author->last_name";
  
  		if ( !($posts == 0 && $hide_empty) ) {
  			$output = "<li>";
			}
			
  		if ( $posts == 0 ) {
  			if (!$hide_empty) {
  				$link = $name;
				}
  		} else {
  			$link = '<a href="' . get_author_link(0, $author->ID, $author->user_nicename) . '" title="' . sprintf(__("Posts by %s"), wp_specialchars($author->display_name)) . '">' . $name . '</a>';
  
  			if ( (! empty($feed_image)) || (! empty($feed)) ) {
  				$link .= ' ';
  				if (empty($feed_image))
  					$link .= '(';
  				$link .= '<a href="' . get_author_rss_link(0, $author->ID, $author->user_nicename) . '"';
  
  				if ( !empty($feed) ) {
  					$title = ' title="' . $feed . '"';
  					$alt = ' alt="' . $feed . '"';
  					$name = $feed;
  					$link .= $title;
  				}
  
  				$link .= '>';
  
  				if ( !empty($feed_image) )
  					$link .= "<img src=\"$feed_image\" border=\"0\"$alt$title" . ' />';
  				else
  					$link .= $name;
  
  				$link .= '</a>';
  
  				if ( empty($feed_image) )
  					$link .= ')';
  			}
  
  			if ( $optioncount )
  				$link .= ' ('. $posts . ')';
  
  		}
  
  		if ( !($posts == 0 && $hide_empty) )
  			$output = "$link</li>";
  	}
	}
	return $output;
}

function AuthorFullName($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	
	return "$author->first_name $author->last_name";
}
function AuthorFirstName($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->first_name;
}
function AuthorLastName($token, $parameters) {
	$author = get_userdata( $parametersken->author->ID );
	return $author->last_name;
}
function AuthorNickName($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->nickname;
}
function AuthorURL($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return get_author_link(0, $author->ID, $author->user_nicename);
}
function AuthorDisplayName($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
//	echo var_dump($author);
	return wp_specialchars($author->display_name);
}
function AuthorRssURL($token, $parameters) {
	$author = get_userdata( $parametersken->author->ID );
	return get_author_rss_link(0, $author->ID, $author->user_nicename);
}
function AuthorTotalPosts($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return get_usernumposts($author->ID);
}
function AuthorAIM($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->aim;
}
function AuthorYIM($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->yim;
}
function AuthorICQ($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->icq;
}
function AuthorMSN($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->msn;
}
function AuthorJabber($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->jabber;
}
function AuthorPostsURL($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->nickname;
}
function AuthorEmail($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->user_email;
}
function AuthorID($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->nickname;
}
function AuthorDescription($token, $parameters) {
	$author = get_userdata( $parameters->author->ID );
	return $author->user_description;
}

/// Category Handlers

function Categories($token, $parameters) {
	$output = '';
	$optionall = (!isset($token['attributes']['optionall'])) ? 1 : $token['attributes']['optionall'];
	$all = (!isset($token['attributes']['all'])) ? 'All' : $token['attributes']['all'];
	$sort_column = (!isset($token['attributes']['sort_column'])) ? 'ID' : $token['attributes']['sort_column'];
	$sort_order = (!isset($token['attributes']['sort_order'])) ? 'asc' : $token['attributes']['sort_order'];
	$file = (!isset($token['attributes']['file'])) ? '' : $token['attributes']['file'];
	$list = (!isset($token['attributes']['list'])) ? true : $token['attributes']['list'];
	$optiondates = (!isset($token['attributes']['optiondates'])) ? 0 : $token['attributes']['optiondates'];
	$optioncount = (!isset($token['attributes']['optioncount'])) ? 0 : $token['attributes']['optioncount'];
	$hide_empty = (!isset($token['attributes']['hide_empty'])) ? 1 : $token['attributes']['hide_empty'];
	$use_desc_for_title = (!isset($token['attributes']['use_desc_for_title'])) ? 1 : $token['attributes']['use_desc_for_title'];
	$children = (!isset($token['attributes']['children'])) ? false : $token['attributes']['children'];
	$child_of = (!isset($token['attributes']['child_of'])) ? 0 : $token['attributes']['child_of'];
	$categories = (!isset($token['attributes']['categories'])) ? 0 : $token['attributes']['categories'];
	$recurse = (!isset($token['attributes']['recurse'])) ? 0 : $token['attributes']['recurse'];
	$feed = (!isset($token['attributes']['feed'])) ? '' : $token['attributes']['feed'];
	$feed_image = (!isset($token['attributes']['feed_image'])) ? '' : $token['attributes']['feed_image'];
	$exclude = (!isset($token['attributes']['exclude'])) ? '' : $token['attributes']['exclude'];
	$hierarchical = (!isset($token['attributes']['hierarchical'])) ? false : $token['attributes']['hierarchical'];
	
	global $wpdb, $wp_query;
	// Optiondates now works
	if ( '' == $file )
		$file = get_settings('home') . '/';

	$exclusions = '';
	if ( !empty($exclude) ) {
		$excats = preg_split('/[\s,]+/',$exclude);
		if ( count($excats) ) {
			foreach ( $excats as $excat ) {
				$exclusions .= ' AND cat_ID <> ' . intval($excat) . ' ';
			}
		}
	}

	$exclusions = apply_filters('list_cats_exclusions', $exclusions );

	if ( intval($categories) == 0 ) {
		$sort_column = 'cat_'.$sort_column;

		$query = "
			SELECT cat_ID, cat_name, category_nicename, category_description, category_parent, category_count
			FROM $wpdb->categories
			WHERE cat_ID > 0 $exclusions
			ORDER BY $sort_column $sort_order";

		$categories = $wpdb->get_results($query);
	}

	if ( $optiondates ) {
		$cat_dates = $wpdb->get_results("	SELECT category_id,
		UNIX_TIMESTAMP( MAX(post_date) ) AS ts
		FROM $wpdb->posts, $wpdb->post2cat, $wpdb->categories
		WHERE post_status = 'publish' AND post_id = ID $exclusions
		GROUP BY category_id");
		foreach ( $cat_dates as $cat_date ) {
			$category_timestamp["$cat_date->category_id"] = $cat_date->ts;
		}
	}

	$num_found=0;
	$thelist = "";
	
	if ($token['type'] == 'container') {
		//echo var_dump($categories);
		foreach ( $categories as $category ) {
			$parameters->category = $category;
			if ( ( intval($hide_empty) == 0 || $category->category_count) && (!$hierarchical || $category->category_parent == $child_of) ) {
				$output .= $this->tmp->call_handlers($parameters, $token['block'], $this);
				if ($hierarchical && $children) {
          $token['attributes']['optionall'] =	$optionall; 
          $token['attributes']['all'] = $all;
          $token['attributes']['sort_column'] = $sort_column;
          $token['attributes']['sort_order'] = $sort_order;
          $token['attributes']['file'] = $file;
          $token['attributes']['list'] = $list;
          $token['attributes']['optiondates'] = $optiondates;
          $token['attributes']['optioncount'] = $optioncount;
          $token['attributes']['hide_empty'] = $hide_empty;
          $token['attributes']['use_desc_for_title'] = $use_desc_for_title;
          $token['attributes']['children'] = $hierarchical;
          $token['attributes']['child_of'] = $category->cat_ID;
          $token['attributes']['categories'] = $categories;
          $token['attributes']['recurse'] = 1;
          $token['attributes']['feed'] = $feed;
          $token['attributes']['feed_image'] = $feed_image;
          $token['attributes']['exclude'] = $exclude;
          $token['attributes']['hierarchical'] = $hierarchical;
  				$output .= Categories($token, $parameters);
  			}
			}
			if ( !$num_found && !$child_of ) {
    		$output = '';
    	}
		}
	} else {	
	
	foreach ( $categories as $category ) {
		if ( ( intval($hide_empty) == 0 || $category->category_count) && (!$hierarchical || $category->category_parent == $child_of) ) {
			$num_found++;
			$link = '<a href="'.get_category_link($category->cat_ID).'" ';
			if ( $use_desc_for_title == 0 || empty($category->category_description) )
				$link .= 'title="'. sprintf(__("View all posts filed under %s"), wp_specialchars($category->cat_name)) . '"';
			else
				$link .= 'title="' . wp_specialchars(apply_filters('category_description',$category->category_description,$category)) . '"';
			$link .= '>';
			$link .= apply_filters('list_cats', $category->cat_name, $category).'</a>';

			if ( (! empty($feed_image)) || (! empty($feed)) ) {

				$link .= ' ';

				if ( empty($feed_image) )
					$link .= '(';

				$link .= '<a href="' . get_category_rss_link(0, $category->cat_ID, $category->category_nicename) . '"';

				if ( !empty($feed) ) {
					$title = ' title="' . $feed . '"';
					$alt = ' alt="' . $feed . '"';
					$name = $feed;
					$link .= $title;
				}

				$link .= '>';

				if ( !empty($feed_image) )
					$link .= "<img src='$feed_image' $alt$title" . ' />';
				else
					$link .= $name;

				$link .= '</a>';

				if (empty($feed_image))
					$link .= ')';
			}

			if ( intval($optioncount) == 1 )
				$link .= ' ('.intval($category->category_count).')';

			if ( $optiondates ) {
				if ( $optiondates == 1 )
					$optiondates = 'Y-m-d';
				$link .= ' ' . gmdate($optiondates, $category_timestamp["$category->cat_ID"]);
			}

			if ( $list ) {
				$thelist .= "\t<li";
				if (($category->cat_ID == $wp_query->get_queried_object_id()) && is_category()) {
					$thelist .=  ' class="current-cat"';
				}
				$thelist .= ">$link\n";
			} else {
				$thelist .= "\t$link<br />\n";
			}

			if ($hierarchical && $children)
				$thelist .= list_cats($optionall, $all, $sort_column, $sort_order, $file, $list, $optiondates, $optioncount, $hide_empty, $use_desc_for_title, $hierarchical, $category->cat_ID, $categories, 1, $feed, $feed_image, $exclude, $hierarchical);
			if ($list)
				$thelist .= "</li>\n";
		}
	}
	if ( !$num_found && !$child_of ) {
		if ( $list ) {
			$before = '<li>';
			$after = '</li>';
		}
		$output =  $before . __("No categories") . $after . "\n";
	}
	if ( $list && $child_of && $num_found && $recurse ) {
		$pre = "\t\t<ul class='children'>";
		$post = "\t\t</ul>\n";
	} else {
		$pre = $post = '';
	}
	$thelist = $pre . $thelist . $post;
	if ( $recurse )
		return $thelist;
	$output = apply_filters('list_cats', $thelist);
	}
	return $output;
}
function CategoryName($token, $parameters) {
	return 	$parameters->category->cat_name;
}
function CategoryDescription($token, $parameters) {
	return 	$parameters->category->cat_description;
}
function CategoryURL($token, $parameters) {
	return 	get_category_link($parameters->category->cat_ID);
}
function CategoryRssURL($token, $parameters) {
	return 	get_category_rss_link(0, $parameters->category->cat_ID, $parameters->category->cat_nicename);
}




}
?>
